/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.provider;

import java.time.Instant;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Metadata</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Metadata#getExtra <em>Extra</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.Metadata#getTimestamp <em>Timestamp</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getMetadata()
 * @model
 * @generated
 */
@ProviderType
public interface Metadata extends EObject {
	/**
	 * Returns the value of the '<em><b>Extra</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.sensinact.model.core.provider.FeatureCustomMetadata}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extra</em>' containment reference list.
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getMetadata_Extra()
	 * @model containment="true"
	 * @generated
	 */
	EList<FeatureCustomMetadata> getExtra();

	/**
	 * Returns the value of the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timestamp</em>' attribute.
	 * @see #setTimestamp(Instant)
	 * @see org.eclipse.sensinact.model.core.provider.ProviderPackage#getMetadata_Timestamp()
	 * @model dataType="org.eclipse.sensinact.model.core.provider.EInstant"
	 * @generated
	 */
	Instant getTimestamp();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.provider.Metadata#getTimestamp <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timestamp</em>' attribute.
	 * @see #getTimestamp()
	 * @generated
	 */
	void setTimestamp(Instant value);

} // Metadata
