/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.provider.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sensinact.gateway.geojson.GeoJsonObject;

import org.eclipse.sensinact.model.core.provider.Admin;
import org.eclipse.sensinact.model.core.provider.ProviderPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Admin</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.impl.AdminImpl#getFriendlyName <em>Friendly Name</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.impl.AdminImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.impl.AdminImpl#getModelPackageUri <em>Model Package Uri</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.provider.impl.AdminImpl#getModel <em>Model</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AdminImpl extends ServiceImpl implements Admin {
	/**
	 * The default value of the '{@link #getFriendlyName() <em>Friendly Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFriendlyName()
	 * @generated
	 * @ordered
	 */
	protected static final String FRIENDLY_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFriendlyName() <em>Friendly Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFriendlyName()
	 * @generated
	 * @ordered
	 */
	protected String friendlyName = FRIENDLY_NAME_EDEFAULT;

	/**
	 * This is true if the Friendly Name attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean friendlyNameESet;

	/**
	 * The default value of the '{@link #getLocation() <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
	protected static final GeoJsonObject LOCATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLocation() <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
	protected GeoJsonObject location = LOCATION_EDEFAULT;

	/**
	 * This is true if the Location attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean locationESet;

	/**
	 * The default value of the '{@link #getModelPackageUri() <em>Model Package Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModelPackageUri()
	 * @generated
	 * @ordered
	 */
	protected static final String MODEL_PACKAGE_URI_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getModelPackageUri() <em>Model Package Uri</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModelPackageUri()
	 * @generated
	 * @ordered
	 */
	protected String modelPackageUri = MODEL_PACKAGE_URI_EDEFAULT;

	/**
	 * This is true if the Model Package Uri attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean modelPackageUriESet;

	/**
	 * The default value of the '{@link #getModel() <em>Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModel()
	 * @generated
	 * @ordered
	 */
	protected static final String MODEL_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getModel() <em>Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModel()
	 * @generated
	 * @ordered
	 */
	protected String model = MODEL_EDEFAULT;

	/**
	 * This is true if the Model attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean modelESet;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdminImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ProviderPackage.Literals.ADMIN;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getFriendlyName() {
		return friendlyName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFriendlyName(String newFriendlyName) {
		String oldFriendlyName = friendlyName;
		friendlyName = newFriendlyName;
		boolean oldFriendlyNameESet = friendlyNameESet;
		friendlyNameESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ProviderPackage.ADMIN__FRIENDLY_NAME, oldFriendlyName, friendlyName, !oldFriendlyNameESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void unsetFriendlyName() {
		String oldFriendlyName = friendlyName;
		boolean oldFriendlyNameESet = friendlyNameESet;
		friendlyName = FRIENDLY_NAME_EDEFAULT;
		friendlyNameESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ProviderPackage.ADMIN__FRIENDLY_NAME, oldFriendlyName, FRIENDLY_NAME_EDEFAULT, oldFriendlyNameESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isSetFriendlyName() {
		return friendlyNameESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public GeoJsonObject getLocation() {
		return location;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLocation(GeoJsonObject newLocation) {
		GeoJsonObject oldLocation = location;
		location = newLocation;
		boolean oldLocationESet = locationESet;
		locationESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ProviderPackage.ADMIN__LOCATION, oldLocation, location, !oldLocationESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void unsetLocation() {
		GeoJsonObject oldLocation = location;
		boolean oldLocationESet = locationESet;
		location = LOCATION_EDEFAULT;
		locationESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ProviderPackage.ADMIN__LOCATION, oldLocation, LOCATION_EDEFAULT, oldLocationESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isSetLocation() {
		return locationESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getModelPackageUri() {
		return modelPackageUri;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModelPackageUri(String newModelPackageUri) {
		String oldModelPackageUri = modelPackageUri;
		modelPackageUri = newModelPackageUri;
		boolean oldModelPackageUriESet = modelPackageUriESet;
		modelPackageUriESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ProviderPackage.ADMIN__MODEL_PACKAGE_URI, oldModelPackageUri, modelPackageUri, !oldModelPackageUriESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void unsetModelPackageUri() {
		String oldModelPackageUri = modelPackageUri;
		boolean oldModelPackageUriESet = modelPackageUriESet;
		modelPackageUri = MODEL_PACKAGE_URI_EDEFAULT;
		modelPackageUriESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ProviderPackage.ADMIN__MODEL_PACKAGE_URI, oldModelPackageUri, MODEL_PACKAGE_URI_EDEFAULT, oldModelPackageUriESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isSetModelPackageUri() {
		return modelPackageUriESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getModel() {
		return model;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModel(String newModel) {
		String oldModel = model;
		model = newModel;
		boolean oldModelESet = modelESet;
		modelESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ProviderPackage.ADMIN__MODEL, oldModel, model, !oldModelESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void unsetModel() {
		String oldModel = model;
		boolean oldModelESet = modelESet;
		model = MODEL_EDEFAULT;
		modelESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ProviderPackage.ADMIN__MODEL, oldModel, MODEL_EDEFAULT, oldModelESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isSetModel() {
		return modelESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ProviderPackage.ADMIN__FRIENDLY_NAME:
				return getFriendlyName();
			case ProviderPackage.ADMIN__LOCATION:
				return getLocation();
			case ProviderPackage.ADMIN__MODEL_PACKAGE_URI:
				return getModelPackageUri();
			case ProviderPackage.ADMIN__MODEL:
				return getModel();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ProviderPackage.ADMIN__FRIENDLY_NAME:
				setFriendlyName((String)newValue);
				return;
			case ProviderPackage.ADMIN__LOCATION:
				setLocation((GeoJsonObject)newValue);
				return;
			case ProviderPackage.ADMIN__MODEL_PACKAGE_URI:
				setModelPackageUri((String)newValue);
				return;
			case ProviderPackage.ADMIN__MODEL:
				setModel((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ProviderPackage.ADMIN__FRIENDLY_NAME:
				unsetFriendlyName();
				return;
			case ProviderPackage.ADMIN__LOCATION:
				unsetLocation();
				return;
			case ProviderPackage.ADMIN__MODEL_PACKAGE_URI:
				unsetModelPackageUri();
				return;
			case ProviderPackage.ADMIN__MODEL:
				unsetModel();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ProviderPackage.ADMIN__FRIENDLY_NAME:
				return isSetFriendlyName();
			case ProviderPackage.ADMIN__LOCATION:
				return isSetLocation();
			case ProviderPackage.ADMIN__MODEL_PACKAGE_URI:
				return isSetModelPackageUri();
			case ProviderPackage.ADMIN__MODEL:
				return isSetModel();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (friendlyName: ");
		if (friendlyNameESet) result.append(friendlyName); else result.append("<unset>");
		result.append(", location: ");
		if (locationESet) result.append(location); else result.append("<unset>");
		result.append(", modelPackageUri: ");
		if (modelPackageUriESet) result.append(modelPackageUri); else result.append("<unset>");
		result.append(", model: ");
		if (modelESet) result.append(model); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //AdminImpl
