/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sensinact.model.core.provider.impl.ServiceImpl;

import org.eclipse.sensinact.model.core.testdata.TestResource;
import org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex;
import org.eclipse.sensinact.model.core.testdata.TestdataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Test Temperatur With Complex</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturWithComplexImpl#getTestResource <em>Test Resource</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TestTemperaturWithComplexImpl extends ServiceImpl implements TestTemperaturWithComplex {
	/**
	 * The cached value of the '{@link #getTestResource() <em>Test Resource</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestResource()
	 * @generated
	 * @ordered
	 */
	protected TestResource testResource;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TestTemperaturWithComplexImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TestdataPackage.Literals.TEST_TEMPERATUR_WITH_COMPLEX;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestResource getTestResource() {
		return testResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTestResource(TestResource newTestResource, NotificationChain msgs) {
		TestResource oldTestResource = testResource;
		testResource = newTestResource;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE, oldTestResource, newTestResource);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTestResource(TestResource newTestResource) {
		if (newTestResource != testResource) {
			NotificationChain msgs = null;
			if (testResource != null)
				msgs = ((InternalEObject)testResource).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE, null, msgs);
			if (newTestResource != null)
				msgs = ((InternalEObject)newTestResource).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE, null, msgs);
			msgs = basicSetTestResource(newTestResource, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE, newTestResource, newTestResource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE:
				return basicSetTestResource(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE:
				return getTestResource();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE:
				setTestResource((TestResource)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE:
				setTestResource((TestResource)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE:
				return testResource != null;
		}
		return super.eIsSet(featureID);
	}

} //TestTemperaturWithComplexImpl
